Subject: [PATCH v2] Update 'make fuzz-all' docs to reflect modern clang

From: "Andrzej Hunt via GitGitGadget" <[email-masked]>
Date: Thu, 04 Mar 2021 15:28:27 +0000

From: Andrzej Hunt <[email-masked]>

Clang no longer produces a libFuzzer.a, instead you can include
libFuzzer by using -fsanitize=fuzzer. Therefore we should use
that in the example command for building fuzzers.

We also add -fsanitize=fuzzer-no-link to ensure that all the required
instrumentation is added when compiling git [1], and remove
 -fsanitize-coverage=trace-pc-guard as it is deprecated.

I happen to have tested with LLVM 11 - however -fsanitize=fuzzer appears to
work in a wide range of reasonably modern clangs.

(On my system: what used to be libFuzzer.a now lives under the following path,
 which is tricky albeit not impossible for a novice such as myself to find:
/usr/lib64/clang/11.0.0/lib/linux/libclang_rt.fuzzer-x86_64.a )

[1] https://releases.llvm.org/11.0.0/docs/LibFuzzer.html#fuzzer-usage

Signed-off-by: Andrzej Hunt <[email-masked]>
---
    Update 'make fuzz-all' docs to reflect modern clang
    
    I have updated my patch to:
    
     * Remove -fsanitize-coverage=trace-pc-guard as it is deprecated.
     * Add -fsanitize=fuzzer-no-link as per Josh's suggestion.

Published-As: https://github.com/gitgitgadget/git/releases/tag/pr-889%2Fahunt%2Ffuzz-docs-v2
Fetch-It-Via: git fetch https://github.com/gitgitgadget/git pr-889/ahunt/fuzz-docs-v2
Pull-Request: https://github.com/gitgitgadget/git/pull/889

Range-diff vs v1:

 1:  d804b24907fd ! 1:  f5b5a11966ca Update 'make fuzz-all' docs to reflect modern clang
     @@ Commit message
          libFuzzer by using -fsanitize=fuzzer. Therefore we should use
          that in the example command for building fuzzers.
      
     +    We also add -fsanitize=fuzzer-no-link to ensure that all the required
     +    instrumentation is added when compiling git [1], and remove
     +     -fsanitize-coverage=trace-pc-guard as it is deprecated.
     +
          I happen to have tested with LLVM 11 - however -fsanitize=fuzzer appears to
          work in a wide range of reasonably modern clangs.
      
     -    (On my system what used to be libFuzzer.a now lives under the following path,
     +    (On my system: what used to be libFuzzer.a now lives under the following path,
           which is tricky albeit not impossible for a novice such as myself to find:
          /usr/lib64/clang/11.0.0/lib/linux/libclang_rt.fuzzer-x86_64.a )
      
     +    [1] https://releases.llvm.org/11.0.0/docs/LibFuzzer.html#fuzzer-usage
     +
          Signed-off-by: Andrzej Hunt <[email-masked]>
      
       ## Makefile ##
     @@ Makefile: cover_db_html: cover_db
      +# An example command to build against libFuzzer from LLVM 11.0.0:
       #
       # make CC=clang CXX=clang++ \
     - #      CFLAGS="-fsanitize-coverage=trace-pc-guard -fsanitize=address" \
     +-#      CFLAGS="-fsanitize-coverage=trace-pc-guard -fsanitize=address" \
      -#      LIB_FUZZING_ENGINE=/usr/lib/llvm-4.0/lib/libFuzzer.a \
     -+#      LIB_FUZZING_ENGINE=-fsanitize=fuzzer \
     ++#      CFLAGS="-fsanitize=fuzzer-no-link,address" \
     ++#      LIB_FUZZING_ENGINE="-fsanitize=fuzzer" \
       #      fuzz-all
       #
       FUZZ_CXXFLAGS ?= $(CFLAGS)

 Makefile | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/Makefile b/Makefile
index dd08b4ced01c..c7248ac6057b 100644
--- a/Makefile
+++ b/Makefile
@@ -3292,11 +3292,11 @@ cover_db_html: cover_db
 # are not necessarily appropriate for general builds, and that vary greatly
 # depending on the compiler version used.
 #
-# An example command to build against libFuzzer from LLVM 4.0.0:
+# An example command to build against libFuzzer from LLVM 11.0.0:
 #
 # make CC=clang CXX=clang++ \
-#      CFLAGS="-fsanitize-coverage=trace-pc-guard -fsanitize=address" \
-#      LIB_FUZZING_ENGINE=/usr/lib/llvm-4.0/lib/libFuzzer.a \
+#      CFLAGS="-fsanitize=fuzzer-no-link,address" \
+#      LIB_FUZZING_ENGINE="-fsanitize=fuzzer" \
 #      fuzz-all
 #
 FUZZ_CXXFLAGS ?= $(CFLAGS)

base-commit: f01623b2c9d14207e497b21ebc6b3ec4afaf4b46
-- 
gitgitgadget